import { QueryMap, BindingOptions, SubscriptionMap, QueryOrMutation } from './types';
import { GraphQLField } from 'graphql';
import { Delegate } from './Delegate';
export interface InstructionsMap {
    [key: string]: Instruction[];
}
export interface Instruction {
    fieldName: string;
    args?: any;
    field: GraphQLField<any, any>;
    fragment: string | object;
    typeName: string;
}
export declare class Binding extends Delegate {
    types: any;
    query: any;
    $subscribe: any;
    debug: any;
    mutation: any;
    currentInstructions: InstructionsMap;
    constructor({schema, fragmentReplacements, before, debug}: BindingOptions);
    buildQueryMethods(operation: QueryOrMutation): QueryMap;
    buildSubscriptionMethods(): SubscriptionMap;
    getOperation(instructions: any): any;
    processInstructions: (id: number) => Promise<any>;
    mapSubscriptionPayload(result: any, instructions: any): AsyncIterator<any>;
    extractPayload(result: any, instructions: any): any;
    execute(operation: any, document: any, variables: any): any;
    then: (id: any, resolve: any, reject: any) => Promise<any>;
    catch: (id: any, reject: any) => Promise<void>;
    generateSelections(instructions: any): {
        ast: any;
        variables: {};
    };
    buildMethods(): void;
    buildDelegateMethods(): void;
    getDelegateMethods(): any;
    buildORMMethods(): void;
    getORMTypes(): any;
    getTypeName(type: any): string;
    getDeepType(type: any): any;
}
