"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var Generator_1 = require("./Generator");
var utils_1 = require("../utils");
var lodash_1 = require("lodash");
var prettier = require("prettier");
var TypescriptGenerator = /** @class */ (function (_super) {
    __extends(TypescriptGenerator, _super);
    function TypescriptGenerator(_a) {
        var schema = _a.schema;
        var _this = _super.call(this, { schema: schema }) || this;
        _this.genericsDelimiter = '=';
        _this.lineBreakDelimiter = '';
        _this.partialType = 'Partial';
        _this.prismaInterface = 'Prisma';
        _this.exportPrisma = true;
        _this.scalarMapping = {
            Int: 'number',
            String: 'string',
            ID: 'string | number',
            Float: 'number',
            Boolean: 'boolean',
            DateTimeInput: 'Date | string',
            DateTimeOutput: 'string',
            Json: 'any',
        };
        _this.graphqlRenderers = {
            GraphQLUnionType: function (type) {
                return _this.renderDescription(type.description) + "export type " + type.name + " = " + type
                    .getTypes()
                    .map(function (t) { return t.name; })
                    .join(' | ');
            },
            GraphQLObjectType: function (type) {
                return (_this.renderInterfaceOrObject(type, true) +
                    '\n\n' +
                    _this.renderInterfaceOrObject(type, false) +
                    '\n\n' +
                    _this.renderInterfaceOrObject(type, false, true));
            },
            GraphQLInterfaceType: function (type) { return _this.renderInterfaceOrObject(type); },
            GraphQLInputObjectType: function (type) {
                var fieldDefinition = Object.keys(type.getFields())
                    .map(function (f) {
                    var field = type.getFields()[f];
                    var isOptional = !graphql_1.isNonNullType(field.type);
                    return "  " + _this.renderFieldName(field, false) + (isOptional ? '?' : '') + ": " + _this.renderInputFieldType(field.type);
                })
                    .join(_this.lineBreakDelimiter + "\n");
                var interfaces = [];
                if (type instanceof graphql_1.GraphQLObjectType) {
                    interfaces = type.getInterfaces();
                }
                return _this.renderInterfaceWrapper(type.name, type.description, interfaces, fieldDefinition);
            },
            GraphQLScalarType: function (type) {
                if (type.name === 'ID') {
                    return _this.graphqlRenderers.GraphQLIDType(type);
                }
                return (type.description
                    ? "/*\n" + type.description + "\n*/\n"
                    : '') + "export type " + type.name + " = " + (_this.scalarMapping[type.name] || 'string');
            },
            GraphQLIDType: function (type) {
                return (type.description
                    ? "/*\n" + type.description + "\n*/\n"
                    : '') + "export type " + type.name + "_Input = " + (_this.scalarMapping[type.name] ||
                    'string') + "\nexport type " + type.name + "_Output = string";
            },
            GraphQLEnumType: function (type) {
                return _this.renderDescription(type.description) + "export type " + type.name + " = " + type
                    .getValues()
                    .map(function (e) { return "  '" + e.name + "'"; })
                    .join(' |\n');
            },
        };
        return _this;
    }
    TypescriptGenerator.prototype.format = function (code, options) {
        if (options === void 0) { options = {}; }
        return prettier.format(code, __assign({}, options, { parser: 'typescript' }));
    };
    TypescriptGenerator.prototype.renderAtLeastOne = function () {
        return "type AtLeastOne<T, U = {[K in keyof T]: Pick<T, K> }> = Partial<T> & U[keyof U]";
    };
    TypescriptGenerator.prototype.render = function (options) {
        return this.format(this.compile(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", "\n// Code generated by Prisma CLI (https://github.com/prisma/prisma). DO NOT EDIT.\n\n", "\n\nexport interface Exists {\n", "\n}\n\nexport interface Node {}\n\n", " interface ", " {\n  $exists: Exists;\n  $graphql: <T ", " any>(query: string, variables?: {[key: string]: any}) => Promise<T>;\n  $delegate: Delegate;\n  $getAbstractResolvers(filterSchema?: GraphQLSchema | string): IResolvers;\n\n  /**\n   * Queries\n  */\n\n", ";\n\n  /**\n   * Mutations\n  */\n\n", ";\n\n\n  /**\n   * Subscriptions\n  */\n\n  $subscribe: Subscription\n\n}\n\nexport interface Subscription {\n", ";\n}\n\nexport interface Delegate {\n  (\n    operation: 'query' | 'mutation',\n    fieldName: string,\n    args: {\n      [key: string]: any\n    },\n    infoOrQuery?: GraphQLResolveInfo,\n    options?: Options,\n  ): Promise<any>", "\n  query: DelegateQuery", "\n  mutation: DelegateMutation", "\n  subscription: DelegateSubscription\n}\n\nexport interface DelegateQuery {\n", "\n}\n\nexport interface DelegateMutation {\n", "\n}\n\nexport interface DelegateSubscription {\n", "\n}\n\n", "\n\n/**\n * Types\n*/\n\n", "\n\n/**\n * Type Defs\n*/\n\n", "\n"], ["\\\n", "\n// Code generated by Prisma CLI (https://github.com/prisma/prisma). DO NOT EDIT.\n\n", "\n\nexport interface Exists {\\n", "\\n}\n\nexport interface Node {}\n\n", " interface ", " {\n  $exists: Exists;\n  $graphql: <T ",
            " any>(query: string, variables?: {[key: string]: any}) => Promise<T>;\n  $delegate: Delegate;\n  $getAbstractResolvers(filterSchema?: GraphQLSchema | string): IResolvers;\n\n  /**\n   * Queries\n  */\n\n", ";\n\n  /**\n   * Mutations\n  */\n\n", ";\n\n\n  /**\n   * Subscriptions\n  */\n\n  $subscribe: Subscription\n\n}\n\nexport interface Subscription {\n", ";\n}\n\nexport interface Delegate {\n  (\n    operation: 'query' | 'mutation',\n    fieldName: string,\n    args: {\n      [key: string]: any\n    },\n    infoOrQuery?: GraphQLResolveInfo,\n    options?: Options,\n  ): Promise<any>", "\n  query: DelegateQuery", "\n  mutation: DelegateMutation", "\n  subscription: DelegateSubscription\n}\n\nexport interface DelegateQuery {\\n", "\\n}\n\nexport interface DelegateMutation {\\n", "\\n}\n\nexport interface DelegateSubscription {\\n", "\\n}\n\n", "\n\n/**\n * Types\n*/\n\n", "\n\n/**\n * Type Defs\n*/\n\n", "\n"])), this.renderImports(), this.renderAtLeastOne(), this.renderExists(), this.exportPrisma ? 'export' : '', this.prismaInterface, this.genericsDelimiter, this.renderQueries(), this.renderMutations(), this.renderSubscriptions(), this.lineBreakDelimiter, this.lineBreakDelimiter, this.lineBreakDelimiter, this.renderDelegateQueries(), this.renderDelegateMutations(), this.renderDelegateSubscriptions(), this.renderBindingConstructor, this.renderTypes(), this.renderExports(options)));
    };
    TypescriptGenerator.prototype.renderBindingConstructor = function () {
        return "export interface BindingConstructor<T> {\n  new(options?: BasePrismaOptions): T\n}";
    };
    TypescriptGenerator.prototype.renderImports = function () {
        return "import { GraphQLResolveInfo, GraphQLSchema } from 'graphql'\nimport { IResolvers } from 'graphql-tools/dist/Interfaces'\nimport { makePrismaBindingClass, BasePrismaOptions, Options } from 'prisma-lib'\nimport { typeDefs } from './graphql'";
    };
    TypescriptGenerator.prototype.renderPrismaClassArgs = function (options) {
        var endpointString = '';
        var secretString = '';
        if (options) {
            if (options.endpoint) {
                endpointString = options.endpoint
                    ? ", endpoint: " + options.endpoint
                    : '';
            }
            if (options.secret) {
                secretString = options.secret ? ", secret: " + options.secret : '';
            }
        }
        return "{typeDefs" + endpointString + secretString + "}";
    };
    TypescriptGenerator.prototype.renderExports = function (options) {
        var args = this.renderPrismaClassArgs(options);
        return "export const Prisma = makePrismaBindingClass<BindingConstructor<" + this.prismaInterface + ">>(" + args + ")\nexport const prisma = new Prisma()";
    };
    TypescriptGenerator.prototype.renderTypedefs = function () {
        return ('export const typeDefs = `' +
            graphql_1.printSchema(this.schema).replace(/`/g, '\\`') +
            '`');
    };
    TypescriptGenerator.prototype.renderExists = function () {
        var queryType = this.schema.getQueryType();
        if (queryType) {
            return "" + utils_1.getExistsTypes(queryType);
        }
        return '';
    };
    TypescriptGenerator.prototype.renderQueries = function () {
        var queryType = this.schema.getQueryType();
        if (!queryType) {
            return '';
        }
        return this.renderMainMethodFields('query', queryType.getFields(), false);
    };
    TypescriptGenerator.prototype.renderMutations = function () {
        var mutationType = this.schema.getMutationType();
        if (!mutationType) {
            return '{}';
        }
        return this.renderMainMethodFields('mutation', mutationType.getFields(), false, true);
    };
    TypescriptGenerator.prototype.renderSubscriptions = function () {
        var queryType = this.schema.getSubscriptionType();
        if (!queryType) {
            return '';
        }
        return this.renderMainMethodFields('subscription', queryType.getFields(), false);
    };
    TypescriptGenerator.prototype.renderDelegateQueries = function () {
        var queryType = this.schema.getQueryType();
        if (!queryType) {
            return '{}';
        }
        return this.renderMainMethodFields('query', queryType.getFields(), true);
    };
    TypescriptGenerator.prototype.renderDelegateMutations = function () {
        var mutationType = this.schema.getMutationType();
        if (!mutationType) {
            return '{}';
        }
        return this.renderMainMethodFields('mutation', mutationType.getFields(), true);
    };
    TypescriptGenerator.prototype.renderDelegateSubscriptions = function () {
        var subscriptionType = this.schema.getSubscriptionType();
        if (!subscriptionType) {
            return '{}';
        }
        return this.renderMainMethodFields('subscription', subscriptionType.getFields(), true);
    };
    TypescriptGenerator.prototype.getTypeNames = function () {
        var ast = this.schema;
        // Create types
        return Object.keys(ast.getTypeMap())
            .filter(function (typeName) { return !typeName.startsWith('__'); })
            .filter(function (typeName) { return typeName !== ast.getQueryType().name; })
            .filter(function (typeName) {
            return ast.getMutationType()
                ? typeName !== ast.getMutationType().name
                : true;
        })
            .filter(function (typeName) {
            return ast.getSubscriptionType()
                ? typeName !== ast.getSubscriptionType().name
                : true;
        })
            .sort(function (a, b) {
            return ast.getType(a).constructor.name <
                ast.getType(b).constructor.name
                ? -1
                : 1;
        });
    };
    TypescriptGenerator.prototype.renderTypes = function () {
        var _this = this;
        var typeNames = this.getTypeNames();
        return lodash_1.flatten(typeNames.map(function (typeName) {
            var forbiddenTypeNames = ['then', 'catch'];
            if (forbiddenTypeNames.includes(typeName)) {
                throw new Error("Cannot use " + typeName + " as a type name as it is reserved.");
            }
            var type = _this.schema.getTypeMap()[typeName];
            if (typeName === 'DateTime') {
                return [
                    _this.graphqlRenderers.GraphQLScalarType({
                        name: 'DateTimeInput',
                        description: 'DateTime scalar input type, allowing Date',
                    }),
                    _this.graphqlRenderers.GraphQLScalarType({
                        name: 'DateTimeOutput',
                        description: 'DateTime scalar output type, which is always a string',
                    }),
                ];
            }
            return _this.graphqlRenderers[type.constructor.name]
                ? _this.graphqlRenderers[type.constructor.name](type)
                : null;
        })).join('\n\n');
    };
    TypescriptGenerator.prototype.renderArgs = function (field, renderInfo, isMutation, isTopLevel, isFragmentAble) {
        var _this = this;
        if (renderInfo === void 0) { renderInfo = false; }
        if (isMutation === void 0) { isMutation = false; }
        if (isTopLevel === void 0) { isTopLevel = false; }
        if (isFragmentAble === void 0) { isFragmentAble = false; }
        var args = field.args;
        var hasArgs = args.length > 0;
        var allOptional = args.reduce(function (acc, curr) {
            if (!acc) {
                return false;
            }
            return !graphql_1.isNonNullType(curr.type);
        }, true);
        var infoString = renderInfo
            ? ', info?: GraphQLResolveInfo, options?: Options'
            : isFragmentAble
                ? ", fragment?: string | Object"
                : "";
        // hard-coded for Prisma ease-of-use
        if (isMutation && field.name.startsWith('create')) {
            return "data" + (allOptional ? '?' : '') + ": " + this.renderInputFieldTypeHelper(args[0], isMutation) + ", fragment?: string | Object";
        }
        else if ((isMutation && field.name.startsWith('delete')) || // either it's a delete mutation
            (!isMutation &&
                isTopLevel &&
                args.length === 1 &&
                (graphql_1.isObjectType(field.type) || graphql_1.isObjectType(field.type.ofType))) // or a top-level single query
        ) {
            return "where" + (allOptional ? '?' : '') + ": " + this.renderInputFieldTypeHelper(args[0], isMutation) + ", fragment?: string | Object";
        }
        return "args" + (allOptional ? '?' : '') + ": {" + (hasArgs ? ' ' : '') + args
            .map(function (a) {
            return "" + _this.renderFieldName(a, false) + (graphql_1.isNonNullType(a.type) ? '' : '?') + ": " + _this.renderInputFieldTypeHelper(a, isMutation);
        })
            .join(', ') + (args.length > 0 ? ' ' : '') + "}" + infoString;
    };
    TypescriptGenerator.prototype.renderInputFieldTypeHelper = function (field, isMutation) {
        return this.renderFieldType({
            field: field,
            node: false,
            input: true,
            partial: false,
            renderFunction: false,
            isMutation: isMutation,
        });
    };
    TypescriptGenerator.prototype.renderMainMethodFields = function (operation, fields, delegate, isMutation) {
        var _this = this;
        if (delegate === void 0) { delegate = false; }
        if (isMutation === void 0) { isMutation = false; }
        return Object.keys(fields)
            .map(function (f) {
            var field = fields[f];
            var T = delegate
                ? "<T " + _this.genericsDelimiter + " " + _this.renderFieldType({
                    field: field,
                    node: delegate,
                    input: false,
                    partial: delegate,
                    renderFunction: false,
                    isMutation: false,
                    isSubscription: operation === 'subscription',
                }) + ">"
                : "<T " + _this.genericsDelimiter + " " + _this.renderFieldType({
                    field: field,
                    node: delegate,
                    input: false,
                    partial: delegate,
                    renderFunction: false,
                    isMutation: isMutation,
                    isSubscription: operation === 'subscription',
                }) + ">";
            return "    " + field.name + ": " + T + "(" + _this.renderArgs(field, delegate, isMutation, true, true) + ") => T";
        })
            .join(';\n');
    };
    TypescriptGenerator.prototype.getDeepType = function (type) {
        if (type.ofType) {
            return this.getDeepType(type.ofType);
        }
        return type;
    };
    TypescriptGenerator.prototype.getInternalTypeName = function (type) {
        var deepType = this.getDeepType(type);
        // if (isListType(type)) {
        //   return `${deepType}Array`
        // }
        var name = String(deepType);
        return name === 'ID' ? 'ID_Output' : name;
    };
    TypescriptGenerator.prototype.getPayloadType = function (operation) {
        if (operation === 'subscription') {
            return "Promise<AsyncIterator<T>>";
        }
        return "Promise<T>";
    };
    TypescriptGenerator.prototype.renderInterfaceOrObject = function (type, node, subscription) {
        var _this = this;
        if (node === void 0) { node = true; }
        if (subscription === void 0) { subscription = false; }
        var fields = type.getFields();
        var fieldDefinition = Object.keys(fields)
            .filter(function (f) {
            var deepType = _this.getDeepType(fields[f].type);
            return node ? !graphql_1.isObjectType(deepType) : true;
        })
            .map(function (f) {
            var field = fields[f];
            return "  " + _this.renderFieldName(field, node) + ": " + _this.renderFieldType({
                field: field,
                node: node,
                input: false,
                partial: false,
                renderFunction: true,
                isMutation: false,
                isSubscription: subscription,
            });
        })
            .join(this.lineBreakDelimiter + "\n");
        var interfaces = [];
        if (type instanceof graphql_1.GraphQLObjectType) {
            interfaces = type.getInterfaces();
        }
        return this.renderInterfaceWrapper("" + type.name + (node ? 'Node' : ''), type.description, interfaces, fieldDefinition, !node, subscription);
    };
    TypescriptGenerator.prototype.renderFieldName = function (field, node) {
        if (!node) {
            return "" + field.name;
        }
        return "" + field.name + (graphql_1.isNonNullType(field.type) ? '' : '?');
    };
    TypescriptGenerator.prototype.wrapType = function (type, subscription) {
        if (subscription === void 0) { subscription = false; }
        if (subscription) {
            return "Promise<AsyncIterator<" + type + ">>";
        }
        return "Promise<" + type + ">";
    };
    TypescriptGenerator.prototype.renderFieldType = function (_a) {
        var field = _a.field, node = _a.node, input = _a.input, partial = _a.partial, renderFunction = _a.renderFunction, _b = _a.isMutation, isMutation = _b === void 0 ? false : _b, _c = _a.isSubscription, isSubscription = _c === void 0 ? false : _c;
        var type = field.type;
        var deepType = this.getDeepType(type);
        var isList = graphql_1.isListType(type) || graphql_1.isListType(type.ofType);
        var isOptional = !(graphql_1.isNonNullType(type) || graphql_1.isNonNullType(type.ofType));
        var isScalar = graphql_1.isScalarType(deepType) || graphql_1.isEnumType(deepType);
        var isInput = field.astNode.kind === 'InputValueDefinition';
        // const isObject = isObjectType(deepType)
        var typeString = this.getInternalTypeName(type);
        if (typeString === 'DateTime') {
            if (isInput) {
                typeString += 'Input';
            }
            else {
                typeString += 'Output';
            }
        }
        var addSubscription = !partial && isSubscription && !isScalar;
        if ((node || isList) && !isScalar && !addSubscription) {
            typeString += "Node";
        }
        if (addSubscription) {
            typeString += 'Subscription';
        }
        if (isScalar && !isInput) {
            if (isList) {
                typeString += "[]";
            }
            if (node) {
                return typeString;
            }
            else {
                return "(" + (field.args && field.args.length > 0
                    ? this.renderArgs(field, isMutation)
                    : '') + ") => " + this.wrapType(typeString, isSubscription);
            }
        }
        if ((isList || node) && isOptional) {
            typeString += ' | null';
        }
        if (isList) {
            if (isScalar) {
                return typeString + "[]";
            }
            else {
                if (renderFunction) {
                    return "<T " + this.genericsDelimiter + " " + this.wrapType("Array<" + typeString, isSubscription) + ">> (" + (field.args && field.args.length > 0
                        ? this.renderArgs(field, isMutation, false, false, true)
                        : '') + ") => T";
                }
                else {
                    return this.wrapType("Array<" + typeString + ">", isSubscription);
                }
            }
        }
        if (partial) {
            typeString = this.partialType + "<" + typeString + ">";
        }
        if (node && (!isInput || isScalar)) {
            return this.wrapType("" + typeString, isSubscription);
        }
        if (isInput || !renderFunction) {
            return typeString;
        }
        // if (node && !typeString.endsWith('Node')) {
        //   typeString = `${typeString}Node`
        // }
        // if (isSubscription && !typeString.endsWith('Subscription')) {
        //   typeString = `${typeStringSubscription}`
        // }
        return "<T " + this.genericsDelimiter + " " + typeString + ">(" + (field.args && field.args.length > 0
            ? this.renderArgs(field, isMutation, false, false, true)
            : '') + ") => T";
    };
    TypescriptGenerator.prototype.renderInputFieldType = function (type) {
        if (graphql_1.isNonNullType(type)) {
            return this.renderInputFieldType(type.ofType);
        }
        if (graphql_1.isListType(type)) {
            var inputType = this.renderInputFieldType(type.ofType);
            if (inputType === 'DateTime') {
                inputType += 'Input';
            }
            return this.renderInputListType(inputType);
        }
        var name = type.name;
        if (name === 'DateTime') {
            name += 'Input';
        }
        return "" + name + (type.name === 'ID' ? '_Input' : '');
    };
    TypescriptGenerator.prototype.renderInputListType = function (type) {
        return type + "[] | " + type;
    };
    TypescriptGenerator.prototype.renderTypeWrapper = function (typeName, typeDescription, fieldDefinition) {
        return this.renderDescription(typeDescription) + "export type " + typeName + " = {\n" + fieldDefinition + "\n}";
    };
    TypescriptGenerator.prototype.renderInterfaceWrapper = function (typeName, typeDescription, interfaces, fieldDefinition, promise, subscription) {
        var actualInterfaces = promise
            ? [
                {
                    name: subscription
                        ? "Promise<AsyncIterator<" + typeName + "Node>>"
                        : "Promise<" + typeName + "Node>",
                },
            ].concat(interfaces)
            : interfaces;
        return "" + this.renderDescription(typeDescription) + (typeName.includes('WhereUniqueInput')
            ? "export type " + typeName + " = AtLeastOne<{\n        " + fieldDefinition + "\n      }>"
            : "export interface " + typeName + (subscription ? 'Subscription' : '') + (actualInterfaces.length > 0
                ? " extends " + actualInterfaces.map(function (i) { return i.name; }).join(', ')
                : '') + " {\n      " + fieldDefinition + "\n      }");
    };
    TypescriptGenerator.prototype.renderDescription = function (description) {
        return "" + (description
            ? "/*\n" + description.split('\n').map(function (l) { return " * " + l + "\n"; }) + "\n */\n"
            : '');
    };
    return TypescriptGenerator;
}(Generator_1.Generator));
exports.TypescriptGenerator = TypescriptGenerator;
var templateObject_1;
//# sourceMappingURL=typescript-client.js.map